<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8"/>
		
	<script src="https://code.jquery.com/jquery-3.4.1.min.js" integrity="sha256-CSXorXvZcTkaix6Yvo6HppcZGetbYMGWSFlBw8HfCJo=" crossorigin="anonymous"></script>
	<script src="jquery-3.4.1.min.js"></script>
    
    <script type="text/javascript" src="https://www.jqwidgets.com/public/jqwidgets/jqx-all.js"></script>
    <script type="text/javascript" src="https://www.jqwidgets.com/public/jqwidgets/globalization/globalize.js"></script>
    <script type="text/javascript" src="https://www.jqwidgets.com/public/jqwidgets/jqxdraw.js"></script>
	
	<script type="text/javascript" src="https://www.jqwidgets.com/public/jqwidgets/jqxbuttons.js"></script>
    <script type="text/javascript" src="https://www.jqwidgets.com/public/jqwidgets/jqxcheckbox.js"></script>
    <script type="text/javascript" src="https://www.jqwidgets.com/public/jqwidgets/jqxslider.js"></script>
	
	<script type="text/javascript" src="main.js"></script>	
	<script type="text/javascript" src="temp.js"></script>
	<script type="text/javascript" src="stepper.js"></script>
	<script type="text/javascript" src="relay.js"></script>
	<script type="text/javascript" src="schedule.js"></script>
	<script type="text/javascript" src="qrcode.min.js"></script>

	<link rel="stylesheet" href="https://www.jqwidgets.com/public/jqwidgets/styles/jqx.base.css" type="text/css" />
    <link rel="stylesheet" href="https://www.jqwidgets.com/public/jqwidgets/styles/jqx.energyblue.css" type="text/css" />	
    <link rel="stylesheet" href="https://www.jqwidgets.com/public/jqwidgets/styles/jqx.office.css" type="text/css" />			
	<link rel="stylesheet" href="https://www.jqwidgets.com/public/jqwidgets/styles/jqx.orange.css" type="text/css" />
	
	<link rel="stylesheet" href="main.css" type="text/css" />	
	<link rel="stylesheet" href="temp.css" type="text/css" />
	<link rel="stylesheet" href="relay.css" type="text/css" />
	<link rel="stylesheet" href="stepper.css" type="text/css" />
	<link rel="stylesheet" href="schedule.css" type="text/css" />

    <script type="text/javascript" language="javascript">						
		var remote = "";//"http://192.168.11.55/";
		var skills;
		var lastResult;
		var lastTempLog = [];
		var lastRelayLog = [];
		var changed = false;
		var setApi = "";
				
		function enableComponents() {								
			if(skills.dht) {
				enableTemp();
			}			
			if(skills.stepper) {
				enableStepper();
			}
			if(skills.relay) {
				enableSchedules();
				enableRelay();
			}
			
			$('#memgage').jqxGauge({
				min:0,
				max:Math.round(skills.maxmem / 1000),

				ticksMinor: { interval: 5, size: '5%' },
				ticksMajor: { interval: 10, size: '9%' },
				value: 0,
				colorScheme: 'scheme01',
				style: { stroke: '#ffffff', 'stroke-width': '1px', fill: '#ffffff' },
				animationDuration: 1800,
				radius: 50,
				width:55,
				startAngle: 0,
				endAngle: 90,         

				showRanges:false,
				border:{ visible: false },
				labels: { 
					visible: true, 
					position: 'outside', 
					interval: Math.round(skills.maxmem / 1000),
					distance: '50px',
					offset: [-4, -16]
				},
			  
				style: { fill: '#00000000', stroke: '#00000000' },
				cap: { radius: 0.04 },
				caption: { value: 'Memory', position: 'left', offset: [10, 10] },
			});
			
			$('#wifigage').jqxGauge({
				min:-90,
				max:-30,

				ticksMinor: { interval: 5, size: '5%' },
				ticksMajor: { interval: 10, size: '9%' },
				value: 0,
				colorScheme: 'scheme01',
				style: { stroke: '#ffffff', 'stroke-width': '1px', fill: '#ffffff' },
				animationDuration: 1800,
				radius: 50,
				width:55,
				startAngle: 0,
				endAngle: 90,         

				showRanges:false,
				border:{ visible: false },
				labels: { 
					visible: true, 
					position: 'outside', 
					interval: 30,
					distance: '50px',
					offset: [-4, -16]
				},
			  
				style: { fill: '#00000000', stroke: '#00000000' },
				cap: { radius: 0.04 },
				caption: { value: 'Wifi', position: 'left', offset: [10, 10] },
			});
									
			$("#automata_console_content").jqxTextArea({ placeHolder: '0 MVSTP=1000,60,10,100,true\r\n3000 MVSTP=1000,60,10,100,false\r\n5000 DISSTP=true', height: 120, width: 480});	
			
			$("#automata_console").jqxWindow({
				autoOpen: false,
				position: { x: $("#bot_icon").offset().left + 40, y: $("#bot_icon").offset().top + 40} , 
				height: 260, width: 500, isModal: true, theme: 'energyblue',
				okButton: $('#save_automata')
			});
									
			$('#automata_console').on('close', function (event) {						
				if (event.type === 'close' && event.args.dialogResult.OK) {																					
					setApi = remote + "api?SETAUTOMATA=" + encodeURIComponent($("#automata_console_content").val().trim().replace(/[\r\n]/g, "|"));				
					changed = true;					
					monitorData();
				}
			});
			
			$("#bot_icon").on('click', function(event) {				
				$("#automata_console_content").jqxTextArea('val', $('#automata_console_text').val())
				$('#automata_console').jqxWindow('open');
			});
								
									
			$("#qr_container").jqxWindow({
				autoOpen: false,
				position: { x: $("#header_icon").offset().left + 80, y: $("#header_icon").offset().top + 80} , 
				height: 445, width: 415, isModal: true, theme: 'energyblue'
			});
			
			var qrcode = new QRCode(document.getElementById("qr_code"), {
					text: '',			
					colorDark : "#000000",
					colorLight : "#ffffff",
					width: 400,
					height: 400,
					correctLevel : QRCode.CorrectLevel.H
				});
				
			$("#header_icon").on('click', function(event) {				
				$('#qr_container').jqxWindow('open');
				qrcode.clear();
				qrcode.makeCode('{"uuid":"' + lastResult.uuid + '", "name":"' + lastResult.name + '", "mqtturl":"' + skills.mqtturl + '","mqttport":' + skills.mqttport + ',"mqttuser":"' + skills.mqttuser + '","mqttpass":"' + skills.mqttpass + '","mqttbasepath":"' + skills.mqttbasepath + '","mqttcmdchannel":"' + skills.mqttcmdchannel + '","mqttcmdjson":"' + skills.mqttcmdjson + '"}');
			});
						
			monitorData();
			
			setTimeout(function(){
				monitorLog();
			}, 500);
		}
		
		function renderResult() {
			renderHeader();
			
			if(skills.dht) {
				renderTemp();
			}
			if(skills.relay) {
				renderRelays(lastResult);
			}
			if(lastResult.schedulesChanged == true) {
				lastResult.schedulesChanged = false;
				renderSchedules();
			}
		}				
		
		$(document).ready(function () {		  						
			getSkills();						
		});
    </script>    
  </head>  
  <body>
	<div id="header_container" class="header_cont">
	
		<img src="iot.png" class="header_icon" id="header_icon"/> 				
		<div id="qr_container" class="qr_container">
			<div>								
				Quick config QR code
			</div>
			<div id="qr_code"></div>
		</div>
			
		<img src="bot.png" class="bot_icon" id="bot_icon"/>		
		<input type="hidden" id="automata_console_text"/>
		<div id="automata_console" class="console_content">
			<div>								
				Automata Console Window
			</div>
			<div>
				<div>
					Add Automata commands below as [timeMs][space][command]		
					command < 50 chars. Space timeUs such as to allow time for previous command to finish.
				</div>	
				<textarea id="automata_console_content"></textarea>
				<div style="float: right; margin-top: 15px;">
					<input type="button" id="save_automata" value="SAVE" style="margin-right: 10px" />										
				</div>								
			</div>
		</div>
		
		<div class="subheader_cont">			
			<span class="identity" id="identity"></span>			
			<br/>			
			<a href="/config">[Config]</a> 
			-
			<span class="clock" id="clock"></span>
		</div>		
		<div class="subheader_cont eithgauge">
			<span id="memgageValue" class="memgauge_value_overlay">12</span> 
			<div id="memgage" class="memgauge"></div>			
		</div>
		<div class="subheader_cont eithgauge">
			<span id="wifigageValue" class="wifigauge_value_overlay">-40</span> 
			<div id="wifigage" class="wifigauge"></div>			
		</div>
		<div class="subheader_cont">
			<span class="mqttstate" id="mqttstate"></span>
		</div>
		<div class="reddot" id="reddot"></div>	
		<div class="error" id="error">An error occured</div>
	</div>

    <div id="temp_container" class="temp_cont">
      <div class="gauge_container">
        <div id="tempGauge" class="fullgauge"></div>
        <div id="tempGaugeValue" class="gauge_value_overlay"></div>      
      </div>
	  
      <div class="gauge_container">
        <div id="humidGauge" class="fullgauge"></div>
        <div id="humidGaugeValue" class="gauge_value_overlay"></div>
      </div>
	  
	  <div class="center_details_container">
		<div class="quartergauge">
          <div style="float:left;" id="heatIndexGauge"></div>
          <div id="heatIndexGaugeValue" class="quartergauge_value_overlay"></div>     
        </div>
        <div class="quartergauge">
          <div style="float:left;" id="dewPointGauge"></div>
          <div id="dewPointGaugeValue" class="quartergauge_value_overlay"></div>      
        </div>
		<div class="comfort_text_cont">
          Comfort Level: <span style="font-weight:bold;" id="comfortlevel" />         
        </div>
	  </div>
      <div class="right_details_container">
        <div class="comfort_cont">
          <div class="comfort_img" id="comfort_hot" >
            <img src="fire.png" />
            <br />
            Hot
          </div>
          <div class="comfort_img" id="comfort_cold" >
            <img src="ice.png" />
            <br />
            Cold
          </div>		  
	    </div>
		<div class="comfort_cont">	    
          <div class="comfort_img" id="comfort_dry" >
            <img src="leaf.png" />
            <br />
            Dry
          </div>
          <div class="comfort_img" id="comfort_wet" >
            <img src="drops.png" />         
            <br />
            Humid
          </div>
        </div>
      </div>      
    </div>
	
    <div id="chart_container" class="chart_container">
      <div id="temp_humid_chart">
      </div>    
    </div>

	<div id="stepper_container" class="stepper_container">
		Stepper control:
		<div class="stepper_control_container">
			<div class="stepper_control_input">
				# of steps (200 = 1 rev):<br />
				<input type="text" id="steps" maxlength="50" size="28" value="400"/> 
			</div>
			<div class="stepper_control_input">
				Step period start (0.1 ms):<br />
				<input type="text" id="startperiod" maxlength="50" size="28" value="50"/> 
			</div>
			<div class="stepper_control_input">
				Step period target (0.1 ms):<br />
				<input type="text" id="targetperiod" maxlength="50" size="28" value="20"/> 
			</div>
			<div class="stepper_control_input">
				Step acceleration (us/step):<br />
				<input type="text" id="acceleration" maxlength="50" size="28" value="50"/> 
			</div>			
			<div class="stepper_op">
				<img src="left.png" class="stepper_op_icon" onclick="moveStepper(false)" alt="Move backward"/>
			</div>
			<div class="stepper_op">
				<img src="del.png" class="stepper_op_icon" onclick="disableStepper()" alt="Disable stepper"/>
			</div>
			<div class="stepper_op">
				<img src="right.png" class="stepper_op_icon" onclick="moveStepper(true)" alt="Move forward"/>
			</div>
		</div>	
	</div>	
	
	<div id="relays_container" class="relays_container">
	</div>	  
	
	<div id="relays_chart_container" class="chart_container">
      <div id="relays_chart">
      </div>    
    </div>
	
	<div class="add_schedule" id="add_schedule">
		Add Schedule:
		<div class="add_schedule_container">
			<div class="add_schedule_name">
				Name:<br />
				<input type="text" id="schedule_name" maxlength="50" size="20"/> 
			</div>							
			<div class="add_schedule_days">
				Days:<br />
				<div id='schedule_days_select'></div>
			</div>
			<div class="add_schedule_onetime">
				<div id="cb_oneTime">One time</div>								
				<div id="schedule_date"></div>
			</div>
			<div class="add_schedule_interval">
				Interval:<br />
				<div id="schedule_from"></div>
				<input type="text" id="schedule_duration" maxlength="30" size="10"/> Sec
			</div>
			<div class="add_schedule_op">
				<img src="clock.png" class="schedule_add" onclick="addSchedule()" alt="Save as new schedule"/>
			</div>
		</div>	
	</div>		
	
	<div class="schedules_container" id="schedules_container">					
	</div>
			
	<div class="bottom_pad" id="bottom_pad">					
	</div>
		
  </body> 
</html>